function tbxStruct=Demos
% DEMOS    Demo List information for Optimization Toolbox

%   Copyright 1990-2001 The MathWorks, Inc.
%   $Revision: 1.11 $  $Date: 2001/03/27 19:55:08 $

if nargout==0, demo toolbox; return; end

tbxStruct.Name='FracLab';
tbxStruct.Type='toolbox';

tbxStruct.Help= {
   
   ' Fraclab is a general purpose signal and image processing '
   ' toolbox based on fractal and multifractal methods.' 
   ' Fraclab can be approached from two different perspectives :' 
   '+Fractal analysis:' 
   ' A large number of procedures allow to compute various fractal'
   ' quantities associated with 1D or 2D signals, such as '
   ' dimensions, Holder exponents or multifractal spectra.' 

   '+Signal processing: '
   ' Alternatively, one can use Fraclab directly to perform many '
   ' basic tasks in signal processing, including estimation, '
   ' detection, denoising, modelling, segmentation,classification,'
   ' and synthesis.' 


   ' Note that Fraclab is not intended to process "fractal" signals '
   ' (whatever meaning is given to this word), but rather to apply '
   ' fractal tools to the study of irregular but otherwise '
   ' arbitrary signals.'
   ' A graphical interface makes Fraclab easy to use and intuitive.'
   ' In addition, various wavelet-related tools are available' 
   ' in Fraclab.' };


tbxStruct.DemoList={  
   'Financial Data analysis','nikkei',
   'Synthetic Aperture Radar image denoising','SARdenoising'
   };







