function Frt=fl_ml2frontier(cmd,context);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[objTmp,ml2Panel] = gcbo;

if ((isempty(ml2Panel)) | (~strcmp(get(ml2Panel,'Tag'),'gui_ml2frontier_control_panel')))
  ml2Panel = findobj ('Tag','gui_ml2frontier_control_panel');
end;

ud = get(ml2Panel,'UserData');
%returnString = '';

switch(cmd);

 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%  INPUT SECTION  %%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    %%%%%%%%%%%%%%%%%%%%
  case 'refresh_input'
    %%%%%%%%%%%%%%%%%%%%
  

    [name flag_error] = fl_get_details;

    if flag_error
      fl_perror('Input must be a matrix !');
      return;
    end

    if ~exist (strtok(name,'.'))
      varname = strtok(name,'.');
      eval ([' global  ' varname]);
   end
    var = eval (name);
    longueur=length(var);
    long=num2str(floor(longueur/2));

    set(findobj(ml2Panel,'Tag','compute'),'Enable','on');
    set(findobj(ml2Panel,'Tag','analysed_point'),'String',long);
    newUd =struct('Function',var,'Precision_frontier',ud.Precision_frontier,'Frontier',ud.Frontier,'Exponents',ud.Exponents,'Choice_estim',ud.Choice_estim,'Choice_example',ud.Choice_example,'Choice_waitbar',ud.Choice_waitbar);
    
    set(ml2Panel,'UserData',newUd);
    edit_input = findobj(ml2Panel,'Tag','EditText_input');
    set(edit_input,'String',name);
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%   2ml-parameters  SECTION   %%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
    %%%%%%%%%%%%%%%%%%%%%%
  case 'precision_exp'
    %%%%%%%%%%%%%%%%%%%%%%
    p=findobj(ml2Panel,'Tag','precision_exp');
    prec=get(p,'Value')*5+5;
    newUd =struct('Function',ud.Function,'Precision_frontier',prec,'Frontier',ud.Frontier,'Exponents',ud.Exponents,'Choice_estim',ud.Choice_estim,'Choice_example',ud.Choice_example,'Choice_waitbar',ud.Choice_waitbar);
    set(ml2Panel,'UserData',newUd);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%   Graph  SECTION   %%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



    %%%%%%%%%%%%%%%%%%%%%%%%
  case 'choice_example'
    %%%%%%%%%%%%%%%%%%%%%%%%

ex_est=findobj(ml2Panel,'Tag','choice_examp');
 example_est=get(ex_est,'Value')-1;
    newUd =struct('Function',ud.Function,'Precision_frontier',ud.Precision_frontier,'Frontier',ud.Frontier,'Exponents',ud.Exponents,'Choice_estim',ud.Choice_estim,'Choice_example',example_est,'Choice_waitbar',ud.Choice_waitbar);
    set(ml2Panel,'UserData',newUd);

    %%%%%%%%%%%%%%%%%%%%%%%%
  case 'choice_estimation'
    %%%%%%%%%%%%%%%%%%%%%%%%

sev_est=findobj(ml2Panel,'Tag','choice_est');
 several_est=get(sev_est,'Value')-1;
    newUd =struct('Function',ud.Function,'Precision_frontier',ud.Precision_frontier,'Frontier',ud.Frontier,'Exponents',ud.Exponents,'Choice_estim',several_est,'Choice_example',ud.Choice_example,'Choice_waitbar',ud.Choice_waitbar);
    set(ml2Panel,'UserData',newUd);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%  Exponents  SECTION   %%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    %%%%%%%%%%%%%%%%%%%%%%%%
  case 'compute_exponents'
    %%%%%%%%%%%%%%%%%%%%%%%%


    comp=get(findobj(ml2Panel,'Tag','compute_exp'),'Value');

    if(comp==1)
	set(findobj(ml2Panel,'Tag','StaticText_pointwise1'),'Enable','off');
	set(findobj(ml2Panel,'Tag','EditText_pointwise1'),'Enable','off');
	set(findobj(ml2Panel,'Tag','StaticText_pointwise2'),'Enable','off');
	set(findobj(ml2Panel,'Tag','EditText_pointwise2'),'Enable','off');
	set(findobj(ml2Panel,'Tag','StaticText_local'),'Enable','off');
	set(findobj(ml2Panel,'Tag','EditText_local'),'Enable','off');
	end;

    if (comp==2)
	set(findobj(ml2Panel,'Tag','StaticText_pointwise1'),'Enable','on');
	set(findobj(ml2Panel,'Tag','EditText_pointwise1'),'Enable','on');
	set(findobj(ml2Panel,'Tag','StaticText_pointwise2'),'Enable','on');
	set(findobj(ml2Panel,'Tag','EditText_pointwise2'),'Enable','on');
	set(findobj(ml2Panel,'Tag','StaticText_local'),'Enable','on');
	set(findobj(ml2Panel,'Tag','EditText_local'),'Enable','on');
	end;

  

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%  Waitbar   SECTION   %%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    %%%%%%%%%%%%%%%%%%%%%%%%
  case 'waitbar_screen'
    %%%%%%%%%%%%%%%%%%%%%%%%
    
    ud = get(ml2Panel,'UserData');
    bar_screen=get(findobj(ml2Panel,'Tag','wait_screen'),'Value');
    
    newUd =struct('Function',ud.Function,'Precision_frontier',ud.Precision_frontier,'Frontier',ud.Frontier,'Exponents',ud.Exponents,'Choice_estim',ud.Choice_estim,'Choice_example',ud.Choice_example,'Choice_waitbar',bar_screen);
    set(ml2Panel,'UserData',newUd);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%  General  SECTION   %%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    %%%%%%%%%%%%%%%%%%%%%%%%
  case 'compute'
    %%%%%%%%%%%%%%%%%%%%%%%%
    
    ud = get(ml2Panel,'UserData');
    if (isempty(ud))
      fl_error('Error : restart the segmentation panel');
      close (ml2Panel);
      return;
    end;

    alpha_p1=0;
    alpha_p2=0;
    alpha_l=0;
    func=ud.Function;
    x=(( (1:max(size(func)))-floor(max(size(func))/2)) /max(size(func)))';   
    point=findobj(ml2Panel,'Tag','analysed_point');
    p=str2num(get(point,'String'));
    if max(size(func))<p
    fl_perror('Point to analyse too large');
    end;	    
    prec=ud.Precision_frontier;
    graph_exa=ud.Choice_example;
    graph_est=ud.Choice_estim;
    waitbar_on=2-ud.Choice_waitbar;
    a=max([p-500 1]);
    b=min([p+500 max(size(func))]);
    mouse = fl_waiton;
    [front,alpha_p1,alpha_p2,alpha_l]=ml2frontier(func(a:b),p-a+1,x(a:b),prec,20,graph_exa,waitbar_on,graph_est,1,1,1);
    

    comp=get(findobj(ml2Panel,'Tag','compute_exp'),'Value');

    if (comp==2)
	pointwise1=findobj(ml2Panel,'Tag','EditText_pointwise1');
	pointwise2=findobj(ml2Panel,'Tag','EditText_pointwise2');
	local=findobj(ml2Panel,'Tag','EditText_local');
	set(pointwise1,'String',num2str(alpha_p1));
	set(pointwise2,'String',num2str(alpha_p2));
	set(local,'String',num2str(alpha_l));
	end;

     % ne pas oublier de creer le userdata.
    sev_est=findobj(ml2Panel,'Tag','choice_est');
    several_est=get(sev_est,'Value')-1;
    newUd =struct('Function',ud.Function,'Precision_frontier',ud.Precision_frontier,'Frontier',front,'Exponents',ud.Exponents,'Choice_estim',several_est,'Choice_example',ud.Choice_example,'Choice_waitbar',ud.Choice_waitbar);
    set(ml2Panel,'UserData',newUd);

    clear varname1;
clear varname2;
clear varname3;
clear varname4;
    outputName1=['frt_' get(findobj(ml2Panel,'Tag','EditText_input'),'String')];
    outputName2=['pw1Exp_' get(findobj(ml2Panel,'Tag','EditText_input'),'String')];
    outputName3=['pw2Exp_' get(findobj(ml2Panel,'Tag','EditText_input'),'String')];
    outputName4=['locExp_' get(findobj(ml2Panel,'Tag','EditText_input'),'String')];
    varname1 = fl_findname(outputName1,context);
    varname2 = fl_findname(outputName2,context);
    varname3 = fl_findname(outputName3,context);
    varname4 = fl_findname(outputName4,context);

    eval(['global ' varname1 '']);
    eval(['global ' varname2 '']);
    eval(['global ' varname3 '']);
    eval(['global ' varname4 '']);
    eval([varname1 '= front;']);
    eval([varname2 '= alpha_p1;']);
    eval([varname3 '= alpha_p2;']);
    eval([varname4 '= alpha_l;']);
    fl_addlist(0,varname1) ;
    fl_addlist(0,varname2) ;
    fl_addlist(0,varname3) ;
    fl_addlist(0,varname4) ;
    fl_waitoff(mouse);
 %   Frt=[varname ' ' Frt];
  


    %%%%%%%%%%%%%%%%%%%%%%%%%%
  case 'help'
    %%%%%%%%%%%%%%%%%%%%%%%%%%
    
if (isempty(ud))
      fl_error('Error : restart the segmentation panel');
      close (ml2Panel);
      return;
    end;


    %%%%%%%%%%%%%%%%%%%%%%%%%%
  case 'close'
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    fl_clearerror;
    close (ml2Panel);
  
  
end % 
