function Frt=fl_ml2frontier(cmd,context);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[objTmp,ml2Panel] = gcbo;

if ((isempty(ml2Panel)) | (~strcmp(get(ml2Panel,'Tag'),'gui_ml2spectrum_control_panel')))
  ml2Panel = findobj ('Tag','gui_ml2spectrum_control_panel');
end;

ud = get(ml2Panel,'UserData');
%returnString = '';

switch(cmd);

 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%  INPUT SECTION  %%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    %%%%%%%%%%%%%%%%%%%%
  case 'refresh_input'
    %%%%%%%%%%%%%%%%%%%%
  

    [name flag_error] = fl_get_details;

    if flag_error
      fl_perror('Input must be a matrix !');
      return;
    end

    if ~exist (strtok(name,'.'))
      varname = strtok(name,'.');
      eval ([' global  ' varname]);
   end
    var = eval (name);

    longueur=length(var);
    long1=num2str(floor(longueur/2)-10);
    long2=num2str(floor(longueur/2)+10);



    set(findobj(ml2Panel,'Tag','compute'),'Enable','on');
    set(findobj(ml2Panel,'Tag','starting_point'),'String',long1);
    set(findobj(ml2Panel,'Tag','ending_point'),'String',long2);

    newUd =struct('Function',var,'Precision_frontier',ud.Precision_frontier,'Frontier',ud.Frontier,'Choice_example',ud.Choice_example,'Choice_waitbar',ud.Choice_waitbar,'Plot_Pointwise_exp',ud.Plot_Pointwise_exp,'Plot_Local_exp',ud.Plot_Local_exp);
    
    set(ml2Panel,'UserData',newUd);
    edit_input = findobj(ml2Panel,'Tag','EditText_input');
    set(edit_input,'String',name);
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%   2ml-parameters  SECTION   %%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
    %%%%%%%%%%%%%%%%%%%%%%
  case 'precision_exp'
    %%%%%%%%%%%%%%%%%%%%%%
    p=findobj(ml2Panel,'Tag','precision_exp');
    prec=get(p,'Value')*5+5;
    newUd =struct('Function',ud.Function,'Precision_frontier',prec,'Frontier',ud.Frontier,'Choice_example',ud.Choice_example,'Choice_waitbar',ud.Choice_waitbar,'Plot_Pointwise_exp',ud.Plot_Pointwise_exp,'Plot_Local_exp',ud.Plot_Local_exp);
    set(ml2Panel,'UserData',newUd);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%   Graph  SECTION   %%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



    %%%%%%%%%%%%%%%%%%%%%%%%
  case 'choice_example'
    %%%%%%%%%%%%%%%%%%%%%%%%

ex_est=findobj(ml2Panel,'Tag','choice_examp');
 example_est=get(ex_est,'Value')-1;
    newUd =struct('Function',ud.Function,'Precision_frontier',ud.Precision_frontier,'Frontier',ud.Frontier,'Choice_example',example_est,'Choice_waitbar',ud.Choice_waitbar,'Plot_Pointwise_exp',ud.Plot_Pointwise_exp,'Plot_Local_exp',ud.Plot_Local_exp);
    set(ml2Panel,'UserData',newUd);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%  Exponents  SECTION   %%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

     %%%%%%%%%%%%%%%%%%%%%%%%
  case 'plot_pointwise'
    %%%%%%%%%%%%%%%%%%%%%%%%

pointw=findobj(ml2Panel,'Tag','pointwise_p');
 pointw_p=get(pointw,'Value');
    newUd =struct('Function',ud.Function,'Precision_frontier',ud.Precision_frontier,'Frontier',ud.Frontier,'Choice_example',ud.Choice_example,'Choice_waitbar',ud.Choice_waitbar,'Plot_Pointwise_exp',pointw_p,'Plot_Local_exp',ud.Plot_Local_exp);
    set(ml2Panel,'UserData',newUd);
 
     %%%%%%%%%%%%%%%%%%%%%%%%
  case 'plot_local'
    %%%%%%%%%%%%%%%%%%%%%%%%

pointl=findobj(ml2Panel,'Tag','local_p');
 pointl_p=get(pointl,'Value');
    newUd =struct('Function',ud.Function,'Precision_frontier',ud.Precision_frontier,'Frontier',ud.Frontier,'Choice_example',ud.Choice_example,'Choice_waitbar',ud.Choice_waitbar,'Plot_Pointwise_exp',ud.Plot_Pointwise_exp,'Plot_Local_exp',pointl_p);
    set(ml2Panel,'UserData',newUd);
 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%  Waitbar   SECTION   %%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    %%%%%%%%%%%%%%%%%%%%%%%%
  case 'waitbar_screen'
    %%%%%%%%%%%%%%%%%%%%%%%%
    
    ud = get(ml2Panel,'UserData');
    bar_screen=get(findobj(ml2Panel,'Tag','wait_screen'),'Value');
    
    newUd =struct('Function',ud.Function,'Precision_frontier',ud.Precision_frontier,'Frontier',ud.Frontier,'Choice_example',ud.Choice_example,'Choice_waitbar',bar_screen,'Plot_Pointwise_exp',ud.Plot_Pointwise_exp,'Plot_Local_exp',ud.Plot_Local_exp);
    set(ml2Panel,'UserData',newUd);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%  General  SECTION   %%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    %%%%%%%%%%%%%%%%%%%%%%%%
  case 'compute'
    %%%%%%%%%%%%%%%%%%%%%%%%
    
    ud = get(ml2Panel,'UserData');
    mouse = fl_waiton;
    if (isempty(ud))
      fl_error('Error : restart the segmentation panel');
      close (ml2Panel);
      return;
    end;

    func=ud.Function;
    x=(((1:max(size(func)))-floor(max(size(func))/2))/max(size(func)))';   
    p1=findobj(ml2Panel,'Tag','starting_point');
    p2=findobj(ml2Panel,'Tag','ending_point');

    point1=str2num(get(p1,'String'));
    point2=str2num(get(p2,'String'));
    prec=ud.Precision_frontier;
    graph_exa=ud.Choice_example;
    waitbar_on=2-ud.Choice_waitbar;
    graph_pointwise=2-ud.Plot_Pointwise_exp;
    graph_local=2-ud.Plot_Local_exp;

    a=max([point1-450 1]);
    b=min([point2+450 max(size(func))]);
    newpoint1=point1-a+1;
    newpoint2=point2-a+1;


    [res]=ml2spectrum(func(a:b),x(a:b),newpoint1,newpoint2,prec,graph_exa,waitbar_on,graph_pointwise,graph_local);

    front=res(:,1:prec);
    ap1=res(:,prec+1);
    ap2=res(:,prec+2);
    al=res(:,prec+3);
    

    comp=get(findobj(ml2Panel,'Tag','compute_exp'),'Value');


     % ne pas oublier de creer le userdata.
    newUd =struct('Function',ud.Function,'Precision_frontier',ud.Precision_frontier,'Frontier',res,'Choice_example',ud.Choice_example,'Choice_waitbar',ud.Choice_waitbar,'Plot_Pointwise_exp',ud.Plot_Pointwise_exp,'Plot_Local_exp',ud.Plot_Local_exp);
    set(ml2Panel,'UserData',newUd);

    clear varname1;
clear varname2;
clear varname3;
clear varname4;
outputName1=['Frt_' get(findobj(ml2Panel,'Tag','EditText_input'),'String')];
    outputName2=['Pw1Exp_' get(findobj(ml2Panel,'Tag','EditText_input'),'String')];
    outputName3=['Pw2Exp_' get(findobj(ml2Panel,'Tag','EditText_input'),'String')];
    outputName4=['LocExp_' get(findobj(ml2Panel,'Tag','EditText_input'),'String')];
    varname1 = fl_findname(outputName1,context);
    varname2 = fl_findname(outputName2,context);
    varname3 = fl_findname(outputName3,context);
    varname4 = fl_findname(outputName4,context);

    varname1 = fl_findname(outputName1,context);
    varname2 = fl_findname(outputName2,context);
    varname3 = fl_findname(outputName3,context);
    varname4 = fl_findname(outputName4,context);

    eval(['global ' varname1 '']);
    eval(['global ' varname2 '']);
    eval(['global ' varname3 '']);
    eval(['global ' varname4 '']);
    eval([varname1 '= front;']);
    eval([varname2 '= ap1;']);
    eval([varname3 '= ap2;']);
    eval([varname4 '= al;']);

    fl_addlist(0,varname1) ;
    fl_addlist(0,varname2) ;
    fl_addlist(0,varname3) ;
    fl_addlist(0,varname4) ;
    fl_waitoff(mouse);
 


    %%%%%%%%%%%%%%%%%%%%%%%%%%
  case 'help'
    %%%%%%%%%%%%%%%%%%%%%%%%%%
    
if (isempty(ud))
      fl_error('Error : restart the segmentation panel');
      close (ml2Panel);
      return;
    end;


    %%%%%%%%%%%%%%%%%%%%%%%%%%
  case 'close'
    %%%%%%%%%%%%%%%%%%%%%%%%%%

    fl_clearerror;
    close (ml2Panel);
  
  
end % 
