function [varargout]=fl_oscP_compute(varargin)

varOutstring=[];
warning off;
% [objTmp,fig] = gcbo;
oscP_fig = gcf;
if ((isempty(oscP_fig)) | (~strcmp(get(oscP_fig,'Tag'),'Fig_gui_fl_oscP')))
  oscP_fig = findobj ('Tag','Fig_gui_fl_oscP');
end

% oscP_fig

switch(varargin{1})


  case 'editNmin'
	value=str2num(get(gcbo,'String'));
	value=floor(value);
	fl_clearerror;
	inputName=get(findobj(oscP_fig,'Tag','EditText_sig_nname_oscP'),'String');
	if isempty(inputName)
	  fl_perror('Input signal must be initiated: Refresh!');
	else 
	  if(value<2)
	    value=2;
	  else
	    eval(['global ' inputName]);
	    eval(['N = max(size(' inputName '));']);
	    if(value>N/3)
	      value=floor(N/3);
	    end 
	  end
	  set(gcbo,'String',num2str(value));
	end
	
  case 'ppm_Nmin'
	index=get(gcbo,'Value');
	values=get(gcbo,'String');
	set(findobj(oscP_fig,'Tag','EditText_Nmin_oscP'),'String',values{index});
	  
  case 'editNmax'
	value=str2num(get(gcbo,'String'));
	value=floor(value);
	fl_clearerror;
	inputName=get(findobj(oscP_fig,'Tag','EditText_sig_nname_oscP'),'String');
	if isempty(inputName)
	  fl_perror('Input signal must be initiated: Refresh!');
	else 
	  eval(['global ' inputName]);
	  eval(['N = max(size(' inputName '));']);
	  valuemin=str2num(get(findobj(oscP_fig,'Tag','EditText_Nmin_oscP'),'String'));
	  if(value<valuemin)
	    value=valuemin;
	  else
	    if(value>2*N/3)
	      value=floor(2*N/3);
	    end 
	  end
	  set(gcbo,'String',num2str(value));
	end
      
  case 'ppm_Nmax'
	index=get(gcbo,'Value');
	values=get(gcbo,'String');
	set(findobj(oscP_fig,'Tag','EditText_Nmax_oscP'),'String',values{index});

	
   case 'refresh'
	fl_clearerror;
	[inputName flag_error]=fl_get_input('matrix');
	if flag_error
	  fl_perror('Invalid: input signal must be a matrix !');
	else 
	  eval(['global ' inputName]);
	  eval(['[n,p] = size(' inputName ');']);
	  
	  %%%%%%%%%%%%%%% input frame %%%%%%%%%%%
	  set(findobj(oscP_fig,'Tag','EditText_size_oscP'), ... 
	      'String',[num2str(n),'x',num2str(p)]);
	  set(findobj(oscP_fig,'Tag','EditText_sig_nname_oscP'), ... 
	      'String',inputName);
	  
  
	  
	  %%%%%%%%%%%%%%% regression frame %%%%%%%%%%%
	  set(findobj(oscP_fig,'Tag','PopupMenu_regtype_oscP'), ... 
	      'Value',1);
	  
  
	end
	
	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Compute oscP
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  case 'compute_oscP'

	current_cursor=fl_waiton;
	
	%%%%% First get the input %%%%%%
	fl_clearerror;
	inputName=get(findobj(oscP_fig,'Tag','EditText_sig_nname_oscP'),'String');
	if isempty(inputName)
	  fl_perror('Input signal must be initiated: Refresh!');
	  fl_waitoff(current_cursor);
	else
	  eval(['global ' inputName]);
	  
	  %%%%%% Disable close and compute %%%%%%%%
	  set(findobj(oscP_fig,'Tag','Pushbutton_wclose_oscP'),'enable','off');
	  set(findobj(oscP_fig,'Tag','Pushbutton_oscP_compute_oscP'),'enable','off');
	  
	  
	  %%%%% Get Nmin and Nmax %%%%%
	  eth=findobj(oscP_fig,'Tag','EditText_Nmin_oscP');
	  Nmin=str2num(get(eth,'String'));
	  eth=findobj(oscP_fig,'Tag','EditText_Nmax_oscP');
	  Nmax=str2num(get(eth,'String'));
	  voices=Nmax-Nmin+1;
	  
	  
	  
	  %%%%% regression argument %%%%%
	  RegType=get(findobj(oscP_fig,'Tag','PopupMenu_regtype_oscP'),'Value');
	  RegParam = fl_getregparam(RegType,voices);
	  
	  
	  %%%%% Perform the computation %%%%%
	  OutputName=['pht_' inputName];
	  varname = fl_findname(OutputName,varargin{2});
	  eval(['global ' varname]);
	  varargout{1}=varname;
	  eval([varname '=oscpholder(', inputName, ',Nmin,Nmax,RegParam{:});']);
	  fl_addlist(0,varname) ;

	  %%%%% store the figure handles %%%%%
	  %global handlefig_oscP
	  %handlefig_oscP=[handlefig_oscP,handlefig];
	  
	  %%%%% Enable to print the new figures %%%%%
	  %if ~isempty(handlefig)
	  %  set(findobj(oscP_fig,'Tag','Pushbutton_wprint_oscP'),'enable','on');
	  %  set(findobj(oscP_fig,'Tag','EditFigHandle_oscP'),'enable','on');
	  %  set(findobj(oscP_fig,'Tag','EditFigHandle_oscP'),'String',num2str(handlefig(1)));
	  %end
	  
	  %%%%% Display the result %%%%%%%%%
	  %set(obj,'String',num2str(dim)) ;
	  
	  fl_waitoff(current_cursor);
	  %%%%%% Enable close and compute %%%%%%%%
	  set(findobj(oscP_fig,'Tag','Pushbutton_wclose_oscP'),'enable','on');
	  set(findobj(oscP_fig,'Tag','Pushbutton_oscP_compute_oscP'),'enable','on');
	  
	end
   
%%%%%%%%% LOCAL SCALING PARAMETERS %%%%%%%%%%%%

  case 'radiobutton_reg'
	Reg = get(gcbo,'Value') ;
	if Reg == 1 
	  set(gcbo,'String','Specify') ;
	elseif Reg == 0
	  set(gcbo,'String','Automatic') ;
	end
	
	
  case 'close'
	h=findobj('tag', 'Fig_gui_fl_oscP');
	close(h);warning backtrace;
	
  case 'help'
        helpwin gui_fl_oscP_help

        
end













