function fig = gui_ml2frontier()

% MAIN WINDOW
a = figure('Color',[0.8 0.8 0.8], ...
	'HandleVisibility','callback', ...
	'MenuBar','none', ...
	'Position',[165 50 360 500], ...
	'Units','pixels', ...
	'UserData',struct('Function',0,'Precision_frontier',10,'Frontier',0,'Choice_estim',0,'Choice_example',0,'Exponents',0,'Choice_waitbar',1), ...
	'Tag','gui_ml2frontier_control_panel');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% TITLE FRAME    
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'ListboxTop',0, ...
	'Position',[0.02 0.895 0.96 0.095], ...
	'Style','frame', ...
	'Tag','Frame_title');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.94 0.8 0.035], ...
	'String','Oscillation based 2-Micro-local Frontier', ...
	'Style','text', ...
	'Tag','StaticText_Title');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.90 0.8 0.035], ...
	'String','Estimation at 1 point (Method 2)', ...
	'Style','text', ...
	'Tag','StaticText_Title');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% INPUT FRAME
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'Position',[0.02 0.825 0.96 0.06], ...
	'Style','frame', ...
	'Tag','Frame_input');

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'FontWeight','bold', ...	
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.835 0.25 0.035], ...
	'String','Input Signal', ...
	'Style','text', ...
	'Tag','StaticText_input');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',12, ...
	'HorizontalAlignment','center', ...
	'Position',[0.32 0.84 0.4 0.035], ...
	'String','', ...
	'Style','text', ...
	'Tag','EditText_input');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'Callback','fl_ml2frontier(''refresh_input'');', ...
	'FontSize',12, ...
	'FontWeight','bold', ...
	'Position',[0.75 0.835 0.175 0.045], ...
	'String','Refresh', ...
	'Tag','Pushbutton_refreshInput');
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2-microlocal frontier FRAME

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'Position',[0.02 0.622 0.96 0.195], ...
	'Style','frame', ...
	'Tag','Frame_Frontier');

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.770 0.8 0.035], ...
	'String','2-microlocal frontier Estimation', ...
	'Style','text', ...
	'Tag','StaticText_ml2fontier');


%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.649 0.60 0.04], ...
	'String','Discretization of the frontier', ...
	'Style','text', ...
	'Tag','StaticText_estim');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'Callback','fl_ml2frontier(''precision_exp'');', ...
	'FontSize',12, ...
	'ListboxTop',0, ...
	'Max',5, ...
	'Min',1, ...
	'Position',[0.625   0.651    0.20    0.05], ...
	'String',{'10','15','20','25','30'}, ...
	'Style','popupmenu', ...
	'Tag','precision_exp', ...
	'Value',1);
%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.704 0.45 0.04], ...
	'String','Point to analyse', ...
	'Style','text', ...
	'Tag','StaticText_point');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',12, ...
	'HorizontalAlignment','center', ...
	'Position',[0.65 0.714 0.15 0.04], ...
	'String','1', ...
	'Style', 'edit', ...
	'Tag','analysed_point');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'Position',[0.02 0.565 0.96 0.050], ...
	'Style','frame', ...
	'Tag','Frame_Results');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.568 0.8 0.035], ...
	'String','Results', ...
	'Style','text', ...
	'Tag','StaticText_ml2fontier');



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Graphs of the 2-microlocal frontier FRAME

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'Position',[0.02 0.425 0.96 0.132], ...
	'Style','frame', ...
	'Tag','Frame_Frontier');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.507 0.8 0.035], ...
	'String','Graphs to be plotted', ...
	'Style','text', ...
	'Tag','StaticText_ml2fontier');


%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.445 0.4 0.04], ...
	'String','Example of estimation', ...
	'Style','text', ...
	'Tag','StaticText_example');


b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'Callback','fl_ml2frontier(''choice_example'');', ...
	'FontSize',12, ...
	'ListboxTop',0, ...
	'Max',2, ...
	'Min',1, ...
	'Position',[0.625  0.445  0.20    0.05], ...
	'String',{'No','Yes'}, ...
	'Style','popupmenu', ...
	'Tag','choice_examp', ...
	'Value',1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Exponents FRAME

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'Position',[0.02 0.155 0.96 0.260], ...
	'Style','frame', ...
	'Tag','Frame_Frontier');

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.370 0.8 0.035], ...
	'String','Regularity exponents', ...
	'Style','text', ...
	'Tag','StaticText_regularity');

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.310 0.65 0.04], ...
	'String','Compute the exponents?', ...
	'Style','text', ...
	'Tag','StaticText_comp');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'Callback','fl_ml2frontier(''compute_exponents'');', ...
	'FontSize',12, ...
	'ListboxTop',0, ...
	'Max',2, ...
	'Min',1, ...
	'Position',[0.625 0.310 0.20  0.05], ...
	'String',{'No','Yes'}, ...
	'Style','popupmenu', ...
	'Tag','compute_exp', ...
	'Value',1);

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'Enable','off',...
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.270 0.65 0.035], ...
	'String','Pointwise exponent(1st method)', ...
	'Style','text', ...
	'Tag','StaticText_pointwise1');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'Enable','off',...
	'BackgroundColor',[1 1 1], ...
	'FontSize',12, ...
	'HorizontalAlignment','center', ...
	'Position',[0.65 0.272 0.15 0.035], ...
	'String','', ...
	'Style','text', ...
	'Tag','EditText_pointwise1');

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'Enable','off',...
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.221 0.65 0.035], ...
	'String','Pointwise exponent(2nd method)', ...
	'Style','text', ...
	'Tag','StaticText_pointwise2');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'BackgroundColor',[1 1 1], ...
	'Enable','off',...
	'FontSize',12, ...
	'HorizontalAlignment','center', ...
	'Position',[0.65 0.220 0.15 0.035], ...
	'String','', ...
	'Style','text', ...
	'Tag','EditText_pointwise2');

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'Enable','off',...
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.172 0.65 0.035], ...
	'String','Local Hoelder exponent', ...
	'Style','text', ...
	'Tag','StaticText_local');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'BackgroundColor',[1 1 1], ...
	'Enable','off',...
	'FontSize',12, ...
	'HorizontalAlignment','center', ...
	'Position',[0.65 0.171 0.15 0.035], ...
	'String','', ...
	'Style','text', ...
	'Tag','EditText_local');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Waitbar FRAME

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'Position',[0.02 0.065 0.96 0.080], ...
	'Style','frame', ...
	'Tag','Frame_Waitbar');

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'FontSize',12, ...
	'FontWeight','bold', ...	
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.080 0.65 0.04], ...
	'String','Waitbar on screen?', ...
	'Style','text', ...
	'Tag','StaticText_wait');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'Callback','fl_ml2frontier(''waitbar_screen'');', ...
	'FontSize',12, ...
	'ListboxTop',0, ...
	'Max',2, ...
	'Min',1, ...
	'Position',[0.625 0.080 0.20  0.05], ...
	'String',{'Yes','No'}, ...
	'Style','popupmenu', ...
	'Tag','wait_screen', ...
	'Value',1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GENERAL BUTTONS



b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'Callback','fl_ml2frontier(''compute'',who);', ...	
	'FontSize',12, ...
	'Enable','off',...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.03 0.01 0.24 0.05], ...
	'String','Compute', ...
	'Tag','compute');

   
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'Callback','helpwin aide_ml2frontier;', ...
	'FontSize',12, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.38 0.01 0.24 0.05], ...
	'String','Help', ...
	'Tag','button_help');   

 
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','pixels', ...
	'Callback','fl_ml2frontier(''close'');', ...
	'FontSize',12, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.73 0.01 0.24 0.05], ...
	'String','Close', ...
	'Tag','button_close');

    
    
if nargout > 0, fig = a; end
