function[ALPHA]=DWTestim_all(in,time,RegParam,type_ond,siz,Reg,Tol,gamma,FindMax,radius,DeepScale,graph)


N=length(in);
n=floor(log2(N));

%%%%%%%%%%% Cration du filtre %%%%%%%%%%%%
q=MakeQMF(type_ond,siz);
[wt,wti,wtl] =FWT(in,n,q);


%%%%%%%%%%% Extraction des coeffs %%%%%%%%%
c=zeros(n,-wti(1)+wti(2));
for j=1:n
   for i=1:-wti(j)+wti(j+1)
      c(n-j+1,i)=wt(wti(j)+i-1);
   end;
end;


%%%%%%%%%%%% Estimation du bruit %%%%%%%%%
sigma=(median(abs(c(n,:))))/0.6745;   
   
   
%%%%%%%%%%% Holder Function %%%%%%%%%%%%%%%%%%%%% 
   
if isempty(time) 

  for point=1:length(in)
     vect_ech1=[];
     vect_log1=[];
     for j=1:n
         vect_ech1=[vect_ech1 j];
         vect_log1=[vect_log1 log2(abs(c(j,ceil((floor((1+point)/2))/2^(n-j)))))];
     end;
     t1=polyfit(vect_ech1,vect_log1,1);
     alpha1=-0.5-t1(1);
     ALPHA_ORIG(point)=alpha1;   
     if strcmp(RegParam,'linf')|strcmp(RegParam,'lsup')
        if FindMax==1
           [vect_ech1,vect_log1]=rad(c,point,radius,DeepScale);
        end;   
        [pente]=newnewreg(vect_ech1,vect_log1,RegParam,Tol,gamma,sigma); 
        alpha2=-0.5-pente(1);
        ALPHA(point)=alpha2;    
     elseif strcmp(RegParam,'ls')
        if FindMax==1
           [vect_ech1,vect_log1]=rad(c,point,radius,DeepScale);
        end;
        t2=monolr(vect_ech1,vect_log1,RegParam{1});
        ALPHA(point)=-0.5-(t2);
        %ALPHA=ALPHA_ORIG;    
     elseif strcmp(RegParam{1},'wls')
        if FindMax==1
           [vect_ech1,vect_log1]=rad(c,point,radius,DeepScale);
        end;
        RegWeight = RegParam{2}(vect_ech1)./sum(RegParam{2}(vect_ech1)) ;
        t2=monolr(vect_ech1,vect_log1,RegParam{1},RegWeight);
        t2=t2(1);
        ALPHA(point)=-0.5-t2;
     elseif strcmp(RegParam{1},'pls')
        if FindMax==1
           [vect_ech1,vect_log1]=rad(c,point,radius,DeepScale);
        end;
        t2=monolr(vect_ech1,vect_log1,RegParam{1},RegParam{2});
        t2=t2(1);
        ALPHA(point)=-0.5-t2;
     elseif strcmp(RegParam{1},'ml')
        if FindMax==1
           [vect_ech1,vect_log1]=rad(c,point,radius,DeepScale);
        end;
        t2=monolr(vect_ech1,vect_log1,RegParam{1});
        t2=t2(1);
        ALPHA(point)=-0.5-(t2);
     elseif strcmp(RegParam{1},'lapls');
        if FindMax==1
           [vect_ech1,vect_log1]=rad(c,point,radius,DeepScale);
        end;
        t2=monolr(vect_ech1,vect_log1,RegParam{1});
        t2=t2(1);
        ALPHA(point)=-0.5-(t2);   
     end;  
  end;

            %%%%%%%%%%%%%%%%%%% Pointwise Holder Exponent %%%%%%%%%%%%


elseif isempty(Reg)|Reg==0  %full range regression
   point=time;
   vect_ech1=[];
   vect_log1=[];
   for j=1:n
         vect_ech1=[vect_ech1 j];
         vect_log1=[vect_log1 log2(abs(c(j,ceil((floor((1+point)/2))/2^(n-j)))))];
   end;
   t1=polyfit(vect_ech1,vect_log1,1);
   alpha1=-0.5-t1(1);
   orig=alpha1;
   
   if strcmp(RegParam,'linf')|strcmp(RegParam,'lsup')
      if FindMax==1
           [vect_ech1,vect_log1]=rad(c,point,radius,DeepScale);
      end;
      [pente]=newnewreg(vect_ech1,vect_log1,RegParam,Tol,gamma,sigma);
      alpha2=-0.5-pente(1);
      ALPHA=alpha2;
      t2=pente(1);b=pente(2);
   elseif strcmp(RegParam,'ls')
      if FindMax==1
           [vect_ech1,vect_log1]=rad(c,point,radius,DeepScale);
      end;
      [t2,b]=monolr(vect_ech1,vect_log1,RegParam{1});
      ALPHA=-0.5-t2(1);
      %ALPHA=alpha1;    
   elseif strcmp(RegParam{1},'wls')
      if FindMax==1
           [vect_ech1,vect_log1]=rad(c,point,radius,DeepScale);
      end;
      RegWeight = RegParam{2}(vect_ech1)./sum(RegParam{2}(vect_ech1)) ;
      [t2,b]=monolr(vect_ech1,vect_log1,RegParam{1},RegWeight);
      t2=t2(1);b=b(1);
      ALPHA=-0.5-t2(1);
   elseif strcmp(RegParam{1},'pls')
      if FindMax==1
           [vect_ech1,vect_log1]=rad(c,point,radius,DeepScale);
      end;
      [t2,b]=monolr(vect_ech1,vect_log1,RegParam{1},RegParam{2});
      t2=t2(1);b=b(1);
      ALPHA=-0.5-t2(1);
   elseif strcmp(RegParam{1},'ml')
      if FindMax==1
           [vect_ech1,vect_log1]=rad(c,point,radius,DeepScale);
      end;
      [t2,b]=monolr(vect_ech1,vect_log1,RegParam{1});
      t2=t2(end);b=b(end);
      ALPHA=-0.5-t2(1);
   elseif strcmp(RegParam{1},'lapls')
      if FindMax==1
           [vect_ech1,vect_log1]=rad(c,point,radius,DeepScale);
      end;
      [t2,b]=monolr(vect_ech1,vect_log1,RegParam{1});
      t2=t2(1);b=b(1);
      ALPHA=-0.5-t2(1);
   end;
   if ~isempty(graph)
    figure;
    plot(vect_ech1,t2(1)*vect_ech1+b,'r');hold;
    plot(vect_ech1,vect_log1,'ko');hold off;
    ALPHA=-0.5-t2(1);
    titre=['Estimated Pointwise Holder Exponent = ',num2str(ALPHA)];
    title(titre);
   end;  
elseif Reg==1 %Specify the range
   point=time;
   vect_ech1=[];
   vect_log1=[];
   for j=1:n
         vect_ech1=[vect_ech1 j];
         vect_log1=[vect_log1 log2(abs(c(j,ceil((floor((1+point)/2))/2^(n-j)))))];
   end;
   if FindMax==1
           [vect_ech1,vect_log1]=rad(c,point,radius,DeepScale);
   end;   
   figure;
   plot(vect_ech1,vect_log1,'ko');
   [borne1,borne2]=fracginput(2);
   long=length(vect_ech1);
   while length(borne1)==2 
      fl_clearerror;
      %%% LLLAAAAAAAAAAAAAAAAAAAAAAAAAAAA
%       vect_ech=vect_ech1(floor(max(1,min(borne1(1),borne1(2)))):floor(min(long,max(borne1(1),borne1(2)))));
%       vect_log=vect_log1(floor(max(1,min(borne1(1),borne1(2)))):floor(min(long,max(borne1(1),borne1(2)))));
      vect_ech=vect_ech1(ceil(max(1,min(borne1(1),borne1(2)))):floor(min(long,max(borne1(1),borne1(2)))));
      vect_log=vect_log1(ceil(max(1,min(borne1(1),borne1(2)))):floor(min(long,max(borne1(1),borne1(2)))));
      if length(vect_ech)==1
         fl_perror('Select more than one point');
         vect_ech=vect_ech1;
         vect_log=vect_log1;
      end;   
      if strcmp(RegParam,'ls')
        [t2,b]=monolr(vect_ech,vect_log,RegParam{1});      
      elseif strcmp(RegParam{1},'wls')
        RegWeight = RegParam{2}(vect_ech)./sum(RegParam{2}(vect_ech)) ;
        [t2,b]=monolr(vect_ech,vect_log,RegParam{1},RegWeight);
        t2=t2(1);b=b(1);
      elseif strcmp(RegParam{1},'pls')
        [t2,b,j,k,o]=monolr(vect_ech,vect_log,RegParam{1},RegParam{2});
        %t2=mean(t2);b=mean(b);
        t2=t2(1);b=b(1);
      elseif strcmp(RegParam{1},'ml')
        [t2,b]=monolr(vect_ech,vect_log,RegParam{1});
        %t2=mean(t2);b=mean(b);
        t2=t2(1);b=b(1);
      elseif strcmp(RegParam{1},'lapls')
        [t2,b]=monolr(vect_ech,vect_log,RegParam{1});
        %t2=mean(t2);b=mean(b);
        t2=t2(1);b=b(1);
      elseif strcmp(RegParam,'linf')|strcmp(RegParam,'lsup')
        [pente]=newnewreg(vect_ech,vect_log,RegParam,Tol,gamma,sigma);
        t2=pente(1);
        b=pente(2);
      end;
      plot(vect_ech1,t2(1)*vect_ech1+b,'r');hold;
      %plot(vect_ech,t2(1)*vect_ech+b,'r*');
      %plot(t2(1)*ones(1,length(vect_ech1))+b,'r');hold;
      plot(vect_ech1,vect_log1,'ko');hold off;
      ALPHA=-0.5-t2(1);
      titre=['Estimated Pointwise Holder Exponent = ',num2str(ALPHA)];
      title(titre);      
      [borne1,borne2]=fracginput(2);
   end; 
end;





   
   

