function [out]=fracreglog(in,trshld)
%Rgularisation de signaux 1D par multiplication des coeff d'ondelettes par un nombre Xj
%entre 0 et 1 constant par echelle
%PL 2000
q=MakeQMF('daubechies',10);
n=floor(log2(max(size(in))));
[wt,wti,wtl,siz] =FWT(in,n,q);
d=trshld/5;N=2^n;

%On met dans chaque ligne j de c les coeff  l'chelle j
%e(j) est l'energie a l'echelle j
c=zeros(n,-wti(1)+wti(2));
for j=1:n
   for i=1:-wti(j)+wti(j+1)
      c(n-j+1,i)=wt(wti(j)+i-1);
   end;
end;

%dfinition des coefficients intervenant dans la rgression
%et donc dans la contrainte. On ne traite pas les nn=int((n+1)/2) 
%premiers coeff
nn=floor((n+1)/2);
o=zeros(1,n-nn);
rap=zeros(1,n-nn);
for j=1:n-nn
   o(j)=j+nn-(n+1)/2;
   rap(j)=(j+nn-(n+1)/2)^2/(2^(j+nn));
end;
somme=sum(rap);
k=12/(n^3-n);

% raz des multiplicateurs
xm=ones(1,n-nn);

% calcul des Xj 
   for j=1:n-nn
      xm(j)=2^(-d*o(j)/(k*2^(j+nn)*somme));
   end;

%calcul des nouveaux coeff obtenus en multipliant les anciens
% partir de nn+1 par les Xj
g=c;
for i=1:(N/2)
  for j=1:n-nn
     g(j+nn,i)=xm(j)*c(j+nn,i);
  end;
end;  

%calcul de la nouvelle TO
rwt=wt;
for j=1:n
   for i=1:-wti(j)+wti(j+1)
      rwt(wti(j)+i-1)=g(n-j+1,i);
   end;
end;

if (d == 0)
  rwt = wt;
end

wtout=rwt;
out=IWT(wtout);
out=out(1:siz);


