function E = logestimerH(x)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%estimer.m permet d'identifier la fonction H(t) d'un mouvement brownien multifractionaire
%introduction de la matrice des donnees du processus a caracteriser
%on utilise des fenetres de taille -(epsilon)log(epsilon)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[taille,p]=size(x);
k=taille;
T=1;
pas=T/k;
v=k^(1/3);
epsilon=1/v;
alpha=zeros(k,1);     
g=(k-2)/2;
h=zeros(k-1,1);
a=zeros(k-1,1);
for i=2:k-1
  for j=2:k-1
    b(i,j)=abs((j-i)/k);
    if b(i,j)<=-epsilon*log(epsilon)
      a(j,1)=(x(j+1,1)-2*x(j,1)+x(j-1,1))^2;
    else
      a(j,1)=0;
    end
  end
  for j=2:1:g
    e(i,j)=abs((2*j-i)/k);
    if e(i,j)<=-epsilon*log(epsilon)
      h(j,1)=(x(2*(j+1),1)-2*x(2*j,1)+x(2*(j-1),1))^2;
    else
      h(j,1)=0;
    end
  end
 f=sum(sum(a)');
 d=sum(sum(h)');
 z=log2(d/f)+1;
 alpha(i,1)=0.5*z;
end
i=2:k-1;
E(i,1)=alpha(i,1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Cette partie permet de tracer le graphe de la fonction identifiee
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%graphe de H
%plot(E,':');
%title('identification de la fonction H') %du processus multifractionnaire: graphes de H et de son estimateur');


